// bleDoc.cpp : implementation of the CBleDoc class
//

#include "stdafx.h"
#include "ble.h"
#include "Poczatek.h"

#include "bleDoc.h"
#include "MainFrm.h"
#include "bleView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBleDoc

IMPLEMENT_DYNCREATE(CBleDoc, CDocument)

BEGIN_MESSAGE_MAP(CBleDoc, CDocument)
	ON_UPDATE_COMMAND_UI(ID_W_SILA_W, OnUpdateSila)
	ON_UPDATE_COMMAND_UI(ID_W_KATPOZ_W, OnUpdateKatpoz)
	ON_UPDATE_COMMAND_UI(ID_W_KATPION_W, OnUpdateKatpion)
	ON_UPDATE_COMMAND_UI(ID_BOMB_ILE, OnUpdateBombIle)
	ON_UPDATE_COMMAND_UI(ID_INDYKATOR_ENERGIA, OnUpdateEnergia)
		//{{AFX_MSG_MAP(CBleDoc)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBleDoc construction/destruction

CBleDoc::CBleDoc()
{
	// TODO: add one-time construction code here
	WartPocz.DoModal();
	odswiez=1;
}

CBleDoc::~CBleDoc()
{
}

BOOL CBleDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	ustawPole(0);
	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CBleDoc serialization

void CBleDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CBleDoc diagnostics

#ifdef _DEBUG
void CBleDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBleDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBleDoc commands

void CBleDoc::OnUpdateSila(CCmdUI *pCmdUI)
{
CString strSila;
char tmp[3];
_itoa(this->Sila, tmp, 10);
strSila = tmp;
pCmdUI->Enable(TRUE);
pCmdUI->SetText(strSila);
}

void CBleDoc::OnUpdateKatpoz(CCmdUI * pCmdUI)
{
CString strKatpoz;
char tmp[3];
_itoa(this->Katpoz, tmp, 10);
strKatpoz = tmp;
pCmdUI->Enable(TRUE);
pCmdUI->SetText(strKatpoz);
}

void CBleDoc::OnUpdateKatpion(CCmdUI * pCmdUI)
{

CString strKatpion;
char tmp[2];
_itoa(this->Katpion, tmp, 10);
strKatpion = tmp;
pCmdUI->Enable(TRUE);
pCmdUI->SetText(strKatpion);
}

void CBleDoc::OnUpdateBombIle(CCmdUI *pCmdUI)
{
CString strBombIle;
char tmp[3];
_itoa(this->bron_ile, tmp, 10);
strBombIle = tmp;
pCmdUI->Enable(TRUE);
pCmdUI->SetText(strBombIle);
}

int CBleDoc::wpiszKatpoz(int nowyKatpoz)
{
this->Katpoz=nowyKatpoz;
//this->OnUpdateKatpoz();
return 1;
}

int CBleDoc::wpiszKatpion(int nowyKatpion)
{
this->Katpion=nowyKatpion;
//this->OnUpdateKatpoz();
return 1;
}

int CBleDoc::wpiszSile(int wartosc)
{
this->Sila=wartosc;
//this->OnUpdateKatpoz();
return 1;

}

int CBleDoc::wpiszBronIle(int wartosc)
{
this->bron_ile=wartosc;
return 1;
}

int CBleDoc::ustawBron(int jaka)
{
	this->wybranaBron[aktGr]=jaka;
	wpiszBronIle(biezacyGracz.bron[jaka]);
	//
	return 1;
}

int CBleDoc::ustawAktGr(int gracz)
{
	this->aktGr=gracz;
	return 1;

}

int CBleDoc::jakaBron()
{
	return (this->wybranaBron[aktGr]);
}

void CBleDoc::ustawPole(int jak)
{
	POSITION pos=GetFirstViewPosition();
	if (pos!=NULL)
	{
		CView* pView=GetNextView(pos);
		if (pView)
		{
			CMainFrame* pFrame=(CMainFrame*) pView->GetTopLevelFrame();
			if (pFrame) pFrame->UstawPole(jak);
		}
	}
}

void CBleDoc::OnUpdateEnergia(CCmdUI * pCmdUI)
{
CString strEnergia;
char tmp[3];
_itoa(biezacyGracz.energia, tmp, 10);
strEnergia = tmp;
pCmdUI->Enable(TRUE);
pCmdUI->SetText(strEnergia);
}

void CBleDoc::daneGracza(cCzolg kto)
{
	biezacyGracz=kto;
    wpiszKatpoz(biezacyGracz.pozKat);
	wpiszKatpion(biezacyGracz.pionKat);
	wpiszSile(biezacyGracz.Sila);
	ustawBron(biezacyGracz.aktywnaBron);
	if (biezacyGracz.podajilebroni()<1) 
	{
		ustawPole(0);
		ustawBron(0);
		biezacyGracz.zmienBron(0);
	};
	wpiszBronIle(biezacyGracz.podajilebroni());

/*	
	POSITION pos=GetFirstViewPosition();
	if (pos!=NULL)
	{
	  CView* pView=GetNextView(pos);
	  if (pView)
	  {
		CMainFrame* pFrame=(CMainFrame*)pView->GetTopLevelFrame();
		if (pFrame) pFrame->ZrobComboDlaGracza(kto);
	  };

	};
*/

}

void CBleDoc::OnFileNew() 
{
	// TODO: Add your command handler code here

	WartPocz.DoModal();
	odswiez=1;
}


void CBleDoc::pobierzDane()
{
	WartPocz.DoModal();
	odswiez=1;

}
