// bleDoc.h : interface of the CBleDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BLEDOC_H__602451EA_4244_11D5_AE3C_00304F066528__INCLUDED_)
#define AFX_BLEDOC_H__602451EA_4244_11D5_AE3C_00304F066528__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "cCzolg.h"
#include "Poczatek.h"	// Added by ClassView

class CBleDoc : public CDocument
{
protected: // create from serialization only
	CBleDoc();
	DECLARE_DYNCREATE(CBleDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBleDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	void pobierzDane();
	int odswiez;
	Poczatek WartPocz;
	void daneGracza(cCzolg kto);
	cCzolg biezacyGracz;
//	int energia;
//	int wpiszEnergia(int wartosc);
	void ustawPole(int jak);
	int jakaBron();
	int ustawAktGr(int gracz);
	int aktGr;
	int wybranaBron[8];
	int ustawBron(int jaka);
	int wpiszBronIle(int wartosc);
	int bron_ile;
	int Sila;
	int wpiszSile(int wartosc);
	int Katpion;
	int wpiszKatpion(int nowyKatpion);
	int Katpoz;
	int wpiszKatpoz(int nowyKatpoz);
	virtual ~CBleDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	afx_msg void OnUpdateEnergia(CCmdUI *pCmdUI);
	afx_msg void OnUpdateBombIle(CCmdUI *pCmdUI);
	afx_msg void OnUpdateKatpion(CCmdUI *pCmdUI);
	afx_msg void OnUpdateKatpoz(CCmdUI *pCmdUI);
	afx_msg void OnUpdateSila(CCmdUI *pCmdUI);
	//{{AFX_MSG(CBleDoc)
	afx_msg void OnFileNew();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BLEDOC_H__602451EA_4244_11D5_AE3C_00304F066528__INCLUDED_)
