// bleView.cpp : implementation of the CBleView class
//

#include "stdafx.h"
#include "ble.h"
#include "Poczatek.h"


#include "bleDoc.h"
#include "bleView.h"

#include "cWiatr.h"
#include "cPocisk.h"
#include "cTeren.h"
#include "cCzolg.h"
#include "Sklepik.h"
#include "MainFrm.h"
// *******************

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//#define ID_TIMER 1
#define PI 3.141

const maxXkw=25;
const maxZkw=25;
const ileKwX=4;
const ileKwZ=4;
int ileGraczy;
cTeren Teren;
cCzolg gracz[8];
cWiatr Wiatr;
bool	keys[256];			// Array Used For The Keyboard Routine
bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;	// Fullscreen Flag Set To Fullscreen Mode By Default
float px=-50.0;
float py=-2.0;
float pz=-17.0;
int katX[8]={60, 60, 60, 60, 60, 60, 60, 60}; // kt obrotu wok osi X
int katY[8]={ 0, 0, 0, 0, 0, 0, 0, 0}; // kt obrotu wok osi Y
int katZ[8]={ 0, 0, 0, 0, 0, 0, 0, 0}; // kt obrotu wok osi Z

//double PI=3.141;
int SklepOn=0;
float kamX[8]={50, 50, 50, 50, 50, 50, 50, 50};
float kamY[8]={70, 70, 70, 70, 70, 70, 70, 70};
float kamZ[8]={87, 87, 87, 87, 87, 87, 87, 87};

float kamR=20;
float krok=3; //krok ruchu
//float kulka[3][ileGraczy]; // x, y, z
int aktywnyGracz=0;
int nastepny=0; // czy nastepny gracz juz moze dzialac
int rundZostalo;
int zajety=0;
Poczatek Startujemy;
int czyOK( int x, int z, int nr)
{
	for (int w=0; w<nr; w++)
	{
		if ((abs(gracz[w].podajX()-x)<8)||(abs(gracz[w].podajZ()-z)<8)) return 0;
	};
	return 1;
};

int ZrobTeren(void)
{
	gracz[aktywnyGracz].aktywuj();
	Teren.generuj();
	for (int i=0; i<ileGraczy; i++)
	{
		int tmpx, tmpz;
		int dalej=0;
		if (i>0)
		{
		do
		{
		 do { tmpx=rand()%100; } while (!((tmpx>4)&&(tmpx<96)));
		 do { tmpz=rand()%100; } while (!((tmpz>4)&&(tmpz<96)));
		 dalej=czyOK(tmpx,tmpz,i);
		} while (dalej!=1);
		}
		else 
		{
			do { tmpx=rand()%100; } while (!((tmpx>4)&&(tmpx<96)));
			do { tmpz=rand()%100; } while (!((tmpz>4)&&(tmpz<96)));
		};
		gracz[i].nadajNumer(i);
		gracz[i].ustaw(tmpx,Teren.wysokosc((int)tmpx,(int)tmpz),tmpz,((rand()%100)/100),((rand()%100)/100),((rand()%100)/100));
	};

	Wiatr.zmienParametry(rand()%360,rand()%10);

 return 1;
};

/*int Podsumowanie(CBleView &okno)
{
  if (okno.SklepOn==1) return 0;
      okno.SklepOn=1;
	  CString podsumowanie, podsumowanie1;
	  podsumowanie="Wyniki (wygrane rundy):\n";
	  for (int a=0;a<ileGraczy;a++)
	  {
		  podsumowanie1.Format("Gracz numer %d - %d\n",(a+1),gracz[a].wygral);
		  podsumowanie=podsumowanie+podsumowanie1;
	  }
	  AfxMessageBox(podsumowanie,MB_ICONINFORMATION);

	  okno.nowaGra();
	  okno.SklepOn=0;
	  return 1;
} */
int IdzDoSklepu(CBleView &okno)
{
  for (int t=0; t<ileGraczy; t++)
  {
	  if (gracz[t].czyZyje()) gracz[t].wygral++;
	  gracz[t].ozyw();
  };
  if (okno.SklepOn==1) return 0;
    rundZostalo--;
    if (rundZostalo<0) rundZostalo=0;
    if (rundZostalo==0)
	{
	  CString podsumowanie, podsumowanie1;
	  podsumowanie="Wyniki (wygrane rundy):\n";
	  for (int a=0;a<ileGraczy;a++)
	  {
		  podsumowanie1.Format("Gracz numer %d - %d\n",(a+1),gracz[a].wygral);
		  podsumowanie=podsumowanie+podsumowanie1;
	  }
	  AfxMessageBox(podsumowanie,MB_ICONINFORMATION);

	  okno.nowaGra();
	  return 0;
	} 

  okno.SklepOn=1;
  for (t=0; t<ileGraczy; t++)
  {
	 okno.m_sklep.DoModal(gracz[t], rundZostalo);
	 gracz[t].fundusze=atoi(okno.m_sklep.m_fundusze);
	 gracz[t].bron[1]+=atoi(okno.m_sklep.m_zakupmalych);
	 gracz[t].bron[2]+=atoi(okno.m_sklep.m_zakupsrednich);
	 gracz[t].bron[3]+=atoi(okno.m_sklep.m_zakupduzych);
  };
  okno.SklepOn=0;
  aktywnyGracz=0;
  for (int r=0; r<ileGraczy; r++)
  gracz[r].deaktywuj();

  gracz[aktywnyGracz].aktywuj();
  okno.GetDocument()->daneGracza(gracz[aktywnyGracz]);
  for (int w=0; w<8; w++)
	{
	katX[w]=60; // kt obrotu wok osi X
    katY[w]=0; // kt obrotu wok osi Y
    katZ[w]=0; // kt obrotu wok osi Z

    kamX[w]=50;
    kamY[w]=70;
    kamZ[w]=87;
	};
  ZrobTeren();
  return 1;
};

/////////////////////////////////////////////////////////////////////////////
// CBleView

IMPLEMENT_DYNCREATE(CBleView, CView)

BEGIN_MESSAGE_MAP(CBleView, CView)
	//{{AFX_MSG_MAP(CBleView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_COMMAND(ID_OBRLEWO, OnObrlewo)
	ON_COMMAND(ID_OBRPRAWO, OnObrprawo)
	ON_COMMAND(ID_OBNIZ, OnObniz)
	ON_COMMAND(ID_PODNIES, OnPodnies)
	ON_COMMAND(ID_ZWSILA, OnZwsila)
	ON_COMMAND(ID_ZMSILA, OnZmsila)
	ON_COMMAND(ID_STRZAL, OnStrzal)
	ON_WM_KEYDOWN()
	ON_WM_TIMER()
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBleView construction/destruction

CBleView::CBleView()
{
	// TODO: add construction code here
	trybMyszy=0;
    m_hGLContext = NULL;
    m_GLPixelIndex = 0;

}

CBleView::~CBleView()
{
}

BOOL CBleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

    cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS);
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBleView drawing

void CBleView::OnDraw(CDC* pDC)
{
	CBleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CBleView diagnostics

#ifdef _DEBUG
void CBleView::AssertValid() const
{
	CView::AssertValid();
}

void CBleView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBleDoc* CBleView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBleDoc)));
	return (CBleDoc*)m_pDocument;
}
#endif //_DEBUG


void CBleView::NoweDane()
{
	GetDocument()->odswiez=0;
	for (int r=0; r<ileGraczy; r++)
  gracz[r].deaktywuj();
  rundZostalo=atoi(GetDocument()->WartPocz.m_ilerundstr);
  ileGraczy=atoi(GetDocument()->WartPocz.m_ilegraczystr);
  for (r=0; r<ileGraczy; r++)
	  gracz[r].reset();
  aktywnyGracz=0;
  gracz[aktywnyGracz].aktywuj();
  for (int i=0; i<8; i++) 
	{
		GetDocument()->ustawAktGr(i);
		GetDocument()->ustawBron(0);
	};
	GetDocument()->ustawAktGr(0);
	GetDocument()->daneGracza(gracz[aktywnyGracz]);
	GetDocument()->wpiszKatpoz(gracz[aktywnyGracz].pozKat);
	GetDocument()->wpiszKatpion(gracz[aktywnyGracz].pionKat);
	GetDocument()->wpiszSile(gracz[aktywnyGracz].Sila);
	GetDocument()->wpiszBronIle(gracz[aktywnyGracz].podajilebroni());
	for (int w=0; w<8; w++)
	{
	katX[w]=60; // kt obrotu wok osi X
    katY[w]=0; // kt obrotu wok osi Y
    katZ[w]=0; // kt obrotu wok osi Z

    kamX[w]=50;
    kamY[w]=70;
    kamZ[w]=87;
	};
	ZrobTeren();  
};

/////////////////////////////////////////////////////////////////////////////
// CBleView message handlers

BOOL CBleView::SetWindowPixelFormat(HDC hDC)
{

	this->SklepOn=0;	
	/*
	rundZostalo=atoi(GetDocument()->WartPocz.m_ilerundstr);
	ileGraczy=atoi(GetDocument()->WartPocz.m_ilegraczystr);
	*/
	NoweDane();
	//GetDocument()->ustawPole(0);


    PIXELFORMATDESCRIPTOR pixelDesc;

    pixelDesc.nSize        = sizeof(PIXELFORMATDESCRIPTOR);
    pixelDesc.nVersion    = 1;

    pixelDesc.dwFlags    =    PFD_DRAW_TO_WINDOW | 
//                    PFD_DRAW_TO_BITMAP | 
                    PFD_SUPPORT_OPENGL | 
					PFD_DOUBLEBUFFER |
                    PFD_STEREO_DONTCARE;

    pixelDesc.iPixelType        = PFD_TYPE_RGBA;
    pixelDesc.cColorBits        = 32;
    pixelDesc.cRedBits        = 8;
    pixelDesc.cRedShift        = 16;
    pixelDesc.cGreenBits        = 8;
    pixelDesc.cGreenShift        = 8;
    pixelDesc.cBlueBits        = 8;
    pixelDesc.cBlueShift        = 0;
    pixelDesc.cAlphaBits        = 0;
    pixelDesc.cAlphaShift        = 0;
    pixelDesc.cAccumBits        = 64;    
    pixelDesc.cAccumRedBits        = 16;
    pixelDesc.cAccumGreenBits    = 16;
    pixelDesc.cAccumBlueBits    = 16;
    pixelDesc.cAccumAlphaBits    = 0;
    pixelDesc.cDepthBits        = 32;
    pixelDesc.cStencilBits        = 8;
    pixelDesc.cAuxBuffers        = 0;
    pixelDesc.iLayerType        = PFD_MAIN_PLANE;
    pixelDesc.bReserved        = 0;
    pixelDesc.dwLayerMask        = 0;
    pixelDesc.dwVisibleMask        = 0;
    pixelDesc.dwDamageMask        = 0;

    m_GLPixelIndex = ChoosePixelFormat( hDC, &pixelDesc);
    if (m_GLPixelIndex==0) // Let's choose a default index.
    {
        m_GLPixelIndex = 1;    
        if (DescribePixelFormat(hDC, m_GLPixelIndex,
            sizeof(PIXELFORMATDESCRIPTOR), &pixelDesc)==0)
        {
            return FALSE;
        }
    }

    if (SetPixelFormat( hDC, m_GLPixelIndex, &pixelDesc)==FALSE)
    {
        return FALSE;
    }


	SetTimer(ID_TIMER, 1000, NULL);
	//SetTimer(ID_TIMER2, 500, NULL);
    return TRUE;


}

int CBleView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	
    HWND hWnd = GetSafeHwnd();
    HDC hDC = ::GetDC(hWnd);

    if (SetWindowPixelFormat(hDC)==FALSE)
        return 0;
    
	if (CreateViewGLContext(hDC)==FALSE)
        return 0;

	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations

    
	return 0;
}

BOOL CBleView::CreateViewGLContext(HDC hDC)
{

    m_hGLContext = wglCreateContext(hDC);
    if (m_hGLContext == NULL)
    {
        return FALSE;
    }

    if (wglMakeCurrent(hDC, m_hGLContext)==FALSE)
    {
        return FALSE;
    }

    return TRUE;

}

void CBleView::OnDestroy() 
{
	KillTimer(ID_TIMER);
	KillTimer(ID_TIMER2);
    if(wglGetCurrentContext()!=NULL) 
    {
        // make the rendering context not current
        wglMakeCurrent(NULL, NULL) ;
    }
    
    if (m_hGLContext!=NULL)
    {
        wglDeleteContext(m_hGLContext);
        m_hGLContext = NULL;
    }

    // Now the associated DC can be released.
    
	CView::OnDestroy();
	
	// TODO: Add your message handler code here
	
}

void CBleView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	
    GLsizei width, height;
    GLdouble aspect;

    width = cx;
    height = cy;

    if (cy==0)
        aspect = (GLdouble)width;
    else
        aspect = (GLdouble)width/(GLdouble)height;

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,1000000.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix}
	glDrawBuffer(GL_BACK);
}

int iluZyje()
{
	int tmp=0;
	for (int r=0; r<ileGraczy; r++)
	{
	  if (gracz[r].czyZyje()) tmp++;
	};
	return tmp;
}

void CBleView::OnPaint() 
{
	if (GetDocument()->odswiez) NoweDane();
	/*if (this->SklepOn==0)
	{
	  if (iluZyje()==1) IdzDoSklepu(*this);
	};*/
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	// Koniec rysowania trjkta 
	//glFlush();

/*
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations
*/	

	

	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Czycimy Ekran i bufor gebokoci
	glLoadIdentity();									// Przenosimy si do pocztku ukadu wsprzdnych
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
   
/*  **************
	glTranslatef(px, py, pz);
	gluLookAt(kamX,kamY,kamZ, (kamX + kamR * sin(katY)),0,(kamZ+ kamR * cos(katY)),0,1,0); 
	************** */
	glRotatef((float)katX[aktywnyGracz],1,0,0);
	glRotatef((float)katY[aktywnyGracz],0,1,0);
	glRotatef((float)katZ[aktywnyGracz],0,0,1);


	glTranslatef(-kamX[aktywnyGracz], -kamY[aktywnyGracz], -kamZ[aktywnyGracz]);

GLfloat LightAmbient[]= { 0.5f, 0.5f, 0.5f, 1.0f }; 
GLfloat LightDiffuse[]= { 1.0f, 1.0f, 1.0f, 1.0f }; 
GLfloat LightPosition[]= { 50.0f, 50.0f, 50.0f, 1.0f }; 
GLfloat SpotExponent[]= {10.0f}; 

glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);
glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);
glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);

glLightfv(GL_LIGHT1, GL_SPOT_EXPONENT, SpotExponent);
	
glEnable(GL_LIGHT1);
glEnable(GL_LIGHTING); 
glTranslatef(0, 30, 0);
/*
	GLUquadricObj *quadratic;
	quadratic=gluNewQuadric(); 
GLfloat MAmbient[]= { 0.5, 0, 0, 1.0f }; 
GLfloat MDiffuse[4]={ 1.0, 0, 0, 1.0f };

	glMaterialfv(GL_FRONT, GL_AMBIENT, MAmbient);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, MDiffuse);

    gluQuadricNormals(quadratic, GLU_SMOOTH); // z generowaniem normalnych

    gluSphere(quadratic,2.0f,32,32);//narysowanie kuli
*/

//	glPushMatrix();

glTranslatef(0, -30, 0);
		int cos;
	cos=gracz[aktywnyGracz].rysuj(Wiatr, Teren);
	if (cos==2)
		{		
			int zasieg;
			float odleglosc;
			//gracz[aktywnyGracz].zmianaEnergii(-10);
			//char ttt[10];
			//_itoa(gracz[aktywnyGracz].energia, ttt, 10);
			//MessageBox(ttt);
			switch (gracz[aktywnyGracz].aktywnaBron)
			{
			case 0: zasieg=4; break;
			case 1: zasieg=6; break;
			case 2: zasieg=8; break;
			case 3: zasieg=12; break;
			default: zasieg=4; break;
			};// okreslamy promien zasiegu
			for (int i=0; i<ileGraczy; i++)
			{
				odleglosc=(float)sqrt(((gracz[aktywnyGracz].pocisk.pX-gracz[i].pozycja[0])*(gracz[aktywnyGracz].pocisk.pX-gracz[i].pozycja[0]))+((gracz[aktywnyGracz].pocisk.pZ-gracz[i].pozycja[2])*(gracz[aktywnyGracz].pocisk.pZ-gracz[i].pozycja[2])))-(zasieg+3);
				if (odleglosc<0) 
				{
					gracz[i].zmianaEnergii((int)(odleglosc*10));
					if (i!=aktywnyGracz) 
					{
						gracz[aktywnyGracz].dodajPunkty((int)(-odleglosc*10));
						gracz[aktywnyGracz].dodajPieniadze((int)(-odleglosc*100));
					};
				};
			};
			 
			for (int x=0; x<ileGraczy; x++) 
			{
				gracz[x].UstawY(Teren.wysokosc(gracz[x].podajX(),gracz[x].podajZ()));
			 };
		};

	for (int i=0; i<ileGraczy; i++)
	{
	 if (i!=aktywnyGracz) gracz[i].rysuj(Wiatr, Teren);
	};
	Wiatr.rysuj();

glDisable(GL_LIGHT1);
glDisable(GL_LIGHTING); 


	Teren.rysuj();
	glEnd();
	glFinish();
	//glDrawBuffer(GL_BACK);
	//glPopMatrix();

//	MessageBox("teraz rysuje, nie przeszkadzaj....");
	SwapBuffers(dc.m_ps.hdc);
	// Do not call CView::OnPaint() for painting messages

			if (nastepny==1)
			{
			 int czyMozna=1;
	 		for (int r=0; r<ileGraczy; r++)
			{
				if (gracz[r].czyStrzela()) 
				{
					czyMozna=0;
//					gracz[r].rysuj();
					Invalidate(FALSE);
					//this->OnPaint();
					break;
				};
			};

			if (czyMozna==1) 
				{
					gracz[aktywnyGracz].deaktywuj();
					if (iluZyje()>1)
					{
					do
					{
					aktywnyGracz++; 
					aktywnyGracz=aktywnyGracz%ileGraczy;
					} while (!gracz[aktywnyGracz].czyZyje());

					GetDocument()->ustawAktGr(aktywnyGracz);
					ustawKombi(gracz[aktywnyGracz].jakaBron());
					gracz[aktywnyGracz].aktywuj();
					nastepny=0;
					GetDocument()->daneGracza(gracz[aktywnyGracz]);
					}
					else 
					{

						if (SklepOn==0) 
						{
//							rundZostalo--;
//							if (rundZostalo==0) Podsumowanie(*this);
							IdzDoSklepu(*this);
						};
					//	MessageBox("Dziekujemy Panstwu. Za chwil zostanie przeprowadzony format dysku systemowego.");
						//for (int r=0; r<ileGraczy; r++)
					//	{	
						//if (SklepOn==0)
						//{
					//		SklepOn=1;
					//	m_sklep.DoModal(gracz[aktywnyGracz].podajFundusze(),1,1,1);
						//};
					//	};
					};
					Invalidate(FALSE);
					//this->OnPaint();
				};
			};

}

void CBleView::OnObrlewo() 
{
	// TODO: Add your command handler code here
	gracz[aktywnyGracz].zmienPoziomy(-5);
	GetDocument()->wpiszKatpoz(gracz[aktywnyGracz].pozKat);
	Invalidate(FALSE);
	//this->OnPaint();
}

void CBleView::OnObrprawo() 
{
	// TODO: Add your command handler code here
	gracz[aktywnyGracz].zmienPoziomy(5);
	GetDocument()->wpiszKatpoz(gracz[aktywnyGracz].pozKat);
	Invalidate(FALSE);
	//this->OnPaint();
}

void CBleView::OnObniz() 
{
	// TODO: Add your command handler code here
	gracz[aktywnyGracz].zmienPionowy(-5);
	GetDocument()->wpiszKatpion(gracz[aktywnyGracz].pionKat);
	Invalidate(FALSE);
	//this->OnPaint();
}

void CBleView::OnPodnies() 
{
	// TODO: Add your command handler code here
	gracz[aktywnyGracz].zmienPionowy(5);
	GetDocument()->wpiszKatpion(gracz[aktywnyGracz].pionKat);
	Invalidate(FALSE);
	//this->OnPaint();
}

void CBleView::OnZwsila() 
{
	// TODO: Add your command handler code here
	gracz[aktywnyGracz].zmienSile(5);
	GetDocument()->wpiszSile(gracz[aktywnyGracz].Sila);
	Invalidate(FALSE);
	//this->OnPaint();
	
}

void CBleView::OnZmsila() 
{
	// TODO: Add your command handler code here
	gracz[aktywnyGracz].zmienSile(-5);
	GetDocument()->wpiszSile(gracz[aktywnyGracz].Sila);
	Invalidate(FALSE);
	//this->OnPaint();
	
}

void CBleView::OnStrzal() 
{
	// TODO: Add your command handler code here
	if (gracz[aktywnyGracz].strzelil==0) gracz[aktywnyGracz].strzal(GetDocument()->jakaBron()); nastepny=1;
	Invalidate(FALSE);
}

void CBleView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
		char wcisniety=char(nChar);

		//char tmp[10];
		//itoa(nChar, tmp, 10);
		//MessageBox(tmp);

	switch (wcisniety)
			{
/*
				case 'D': katY[aktywnyGracz]=katY[aktywnyGracz]+5; katY[aktywnyGracz]=katY[aktywnyGracz]%360;  break; //'d'
				case 'A': katY[aktywnyGracz]=katY[aktywnyGracz]-5; katY[aktywnyGracz]=katY[aktywnyGracz]%360;  break; //'a'
				case 'S': kamZ=(float)(kamZ+krok*cos((float)katY*PI/180)); kamX=(float)(kamX-krok*sin((float)katY*PI/180));break; //'s'
				case 'W': kamZ=(float)(kamZ-krok*cos((float)katY*PI/180)); kamX=(float)(kamX+krok*sin((float)katY*PI/180)); break; //'w'
				case 'O': kamY=kamY+krok; break; //'o'
				case 'L': kamY=kamY-krok; break; //'l'
				case 'I': katX=katX-5; katX=katX%360; break; //'i'
				case 'K': katX=katX+5; katX=katX%360; break; //'k'
  */
  //				case 'R': ZrobTeren(); break; //'r' 
				case 'R':	katX[aktywnyGracz]=60;
							katY[aktywnyGracz]= 0;
							katZ[aktywnyGracz]= 0;
							kamX[aktywnyGracz]=50;
							kamY[aktywnyGracz]=70;
							kamZ[aktywnyGracz]=87;
						break;
				case (char)39: gracz[aktywnyGracz].zmienPoziomy(-5); GetDocument()->wpiszKatpoz(gracz[aktywnyGracz].pozKat);break; // 'M'
				case (char)37: gracz[aktywnyGracz].zmienPoziomy(5); GetDocument()->wpiszKatpoz(gracz[aktywnyGracz].pozKat); break; // 'N' 
				case (char)38: gracz[aktywnyGracz].zmienPionowy(5); GetDocument()->wpiszKatpion(gracz[aktywnyGracz].pionKat);break;
				case (char)40: gracz[aktywnyGracz].zmienPionowy(-5); GetDocument()->wpiszKatpion(gracz[aktywnyGracz].pionKat);break; // 'B' 
				case ' ': if (gracz[aktywnyGracz].strzelil==0) gracz[aktywnyGracz].strzal(GetDocument()->jakaBron()); nastepny=1; break;
				case (char)189: gracz[aktywnyGracz].zmienSile(-5); GetDocument()->wpiszSile(gracz[aktywnyGracz].Sila);break;
				case (char)187: gracz[aktywnyGracz].zmienSile(5); GetDocument()->wpiszSile(gracz[aktywnyGracz].Sila);break;	
				case (char)109: gracz[aktywnyGracz].zmienSile(-5); GetDocument()->wpiszSile(gracz[aktywnyGracz].Sila);break;
				case (char)107: gracz[aktywnyGracz].zmienSile(5); GetDocument()->wpiszSile(gracz[aktywnyGracz].Sila);break;	
//				case '1': gracz[aktywnyGracz].zmienBron(0); GetDocument()->wpiszBronIle(gracz[aktywnyGracz].podajilebroni()); break;//MessageBox("Czego wciskasz te klawiory?!"); break;
//				case '2': gracz[aktywnyGracz].zmienBron(1); GetDocument()->wpiszBronIle(gracz[aktywnyGracz].podajilebroni()); break;
//				case '3': gracz[aktywnyGracz].zmienBron(2); GetDocument()->wpiszBronIle(gracz[aktywnyGracz].podajilebroni()); break;																  
//				case '0': IdzDoSklepu(*this);break;																  
																  /*
				case '2': Wiatr.zmienParametry(0,1); break;
				case '3': Wiatr.zmienParametry(5,0); break;
				case '4': Wiatr.zmienParametry(-5,0); break;
*/
			};

	Invalidate(FALSE);
	//this->OnPaint();
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CBleView::OnTimer(UINT nIDEvent) 
{

	// TODO: Add your message handler code here and/or call default
	
 	if (nIDEvent==ID_TIMER) Wiatr.zmianaWiatru();

/*	if (nIDEvent==ID_TIMER2)
	{
			if (nastepny==1)
			{
			 int czyMozna=1;
	 		for (int r=0; r<ileGraczy; r++)
			{
				if (gracz[r].czyStrzela()) 
				{
					czyMozna=0;
//					gracz[r].rysuj();
					break;
				};
			};

			if (czyMozna==1) 
				{
					gracz[aktywnyGracz].deaktywuj();
					aktywnyGracz++; 
					aktywnyGracz=aktywnyGracz%ileGraczy;
					gracz[aktywnyGracz].aktywuj();
					nastepny=0;
				};
			};
	};*/
	Invalidate(FALSE);
	this->OnPaint();
	CView::OnTimer(nIDEvent);
}

int CBleView::ustawBronAktywnegoGracza(int wart)
{
 gracz[aktywnyGracz].zmienBron(wart);
 return 1;
}

BOOL CBleView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	return TRUE;
	//return CView::OnEraseBkgnd(pDC);
}

void CBleView::ustawKombi(int wart)
{
	GetDocument()->ustawPole(wart);
}

void CBleView::nowaGra()
{
	GetDocument()->pobierzDane();
}

void CBleView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
		if ((trybMyszy==0)||(trybMyszy==2)) trybMyszy+=1;

	CView::OnLButtonDown(nFlags, point);
}

void CBleView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if ((trybMyszy==1)||(trybMyszy==3)) trybMyszy-=1;	
	CView::OnLButtonUp(nFlags, point);
}

void CBleView::OnMouseMove(UINT nFlags, CPoint point) 
{
	int del=3;
	int delk=5;
	// TODO: Add your message handler code here and/or call default
	switch (trybMyszy)
	{
	case 1: if (abs(point.x-oldMouseX)>abs(point.y-oldMouseY))
			{		
			if ((point.x-oldMouseX)>0)
			{
				katY[aktywnyGracz]+=del; 
				katY[aktywnyGracz]=katY[aktywnyGracz]%360;
			}
			else
			{
			 katY[aktywnyGracz]-=del; 
			 katY[aktywnyGracz]=katY[aktywnyGracz]%360;
			};
			}
			else
			{
			if ((point.y-oldMouseY)>0)
			{
				katX[aktywnyGracz]+=del; 
				katX[aktywnyGracz]=katX[aktywnyGracz]%360;
			}
			else
			{
			 katX[aktywnyGracz]-=del; 
			 katX[aktywnyGracz]=katX[aktywnyGracz]%360;
			};
			};
			Invalidate(FALSE);
			break;
	case 2:	if (abs(point.x-oldMouseX)>abs(point.y-oldMouseY))
			{		
			if ((point.x-oldMouseX)>0)
			{
				//kamX[aktywnyGracz]+=delk;				
				kamZ[aktywnyGracz]=kamZ[aktywnyGracz]+delk*sin((float)katY[aktywnyGracz]*PI/180); 
				kamX[aktywnyGracz]=kamX[aktywnyGracz]+delk*cos((float)katY[aktywnyGracz]*PI/180);
			}
			else
			{
			    //kamX[aktywnyGracz]-=delk; 
				kamZ[aktywnyGracz]=kamZ[aktywnyGracz]-delk*sin((float)katY[aktywnyGracz]*PI/180); 
				kamX[aktywnyGracz]=kamX[aktywnyGracz]-delk*cos((float)katY[aktywnyGracz]*PI/180); 			
			
			};
			}
			else
			{
			if ((point.y-oldMouseY)>0)
			{
				//kamZ[aktywnyGracz]+=delk; 
				kamZ[aktywnyGracz]=kamZ[aktywnyGracz]+delk*cos((float)katY[aktywnyGracz]*PI/180); 
				kamX[aktywnyGracz]=kamX[aktywnyGracz]-delk*sin((float)katY[aktywnyGracz]*PI/180);
			}
			else
			{
			    //kamZ[aktywnyGracz]-=delk; 			 
				kamZ[aktywnyGracz]=kamZ[aktywnyGracz]-delk*cos((float)katY[aktywnyGracz]*PI/180); 
				kamX[aktywnyGracz]=kamX[aktywnyGracz]+delk*sin((float)katY[aktywnyGracz]*PI/180); 			};
			};
			Invalidate(FALSE);
			break;
	case 3:	if (abs(point.x-oldMouseX)<abs(point.y-oldMouseY))
			{
			if ((point.y-oldMouseY)>0)
			{
				kamZ[aktywnyGracz]=(float)(kamZ[aktywnyGracz]+krok*cos((float)katY[aktywnyGracz]*PI/180)); 
				kamX[aktywnyGracz]=(float)(kamX[aktywnyGracz]-krok*sin((float)katY[aktywnyGracz]*PI/180));
				kamY[aktywnyGracz]=(float)(kamY[aktywnyGracz]+krok*sin((float)katX[aktywnyGracz]*PI/180));
			}
			else
			{
			 kamZ[aktywnyGracz]=(float)(kamZ[aktywnyGracz]-krok*cos((float)katY[aktywnyGracz]*PI/180)); 
			 kamX[aktywnyGracz]=(float)(kamX[aktywnyGracz]+krok*sin((float)katY[aktywnyGracz]*PI/180));
			 kamY[aktywnyGracz]=(float)(kamY[aktywnyGracz]-krok*sin((float)katX[aktywnyGracz]*PI/180));
			};
			};
			Invalidate(FALSE);
			break;

	default: break;
	};


/*	if (m_LButtonDown)
	{
		CGLSample4Doc* pDoc = GetDocument();
		CSize rotate = m_LDownPos - point;
		m_LDownPos = point;
		
		pDoc->m_yRotate -= rotate.cx/2;
		pDoc->m_xRotate -= rotate.cy/2;
		InvalidateRect(NULL, FALSE);
	}
  */
	oldMouseX=point.x;
	oldMouseY=point.y;
	CView::OnMouseMove(nFlags, point);

}

void CBleView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if ((trybMyszy==0)||(trybMyszy==1)) trybMyszy+=2;
	
	CView::OnRButtonDown(nFlags, point);
}

void CBleView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if ((trybMyszy==2)||(trybMyszy==3)) trybMyszy-=2;		
	CView::OnRButtonUp(nFlags, point);
}
