// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ble.h"
//#include "bleView.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_HELP_OPISKLAWISZY, OnHelpOpisklawiszy)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_CBOMB,OnSelChangeWidth)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_ENERGIA,
	ID_INDYKATOR_ENERGIA,
	ID_W_SILA_O,
	ID_W_SILA_W,
	ID_W_KATPOZ_O,
	ID_W_KATPOZ_W,
	ID_W_KATPION_O,
	ID_W_KATPION_W,
	ID_W_BOMB,
	ID_BOMB_ILE,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	int nSzerokosc = 150;
int nWysokosc = 125;
m_wndToolBar.SetButtonInfo(11, IDC_CBOMB, TBBS_SEPARATOR, nSzerokosc);
CRect rect;
m_wndToolBar.GetItemRect (11, &rect);
rect.bottom=rect.top+nWysokosc;
m_ctrlBomba.Create(WS_CHILD | WS_VISIBLE | WS_VSCROLL | CBS_DROPDOWNLIST, rect, &m_wndToolBar, IDC_CBOMB);
CString szStyle;
if (szStyle.LoadString(IDS_BZWYKLA)) m_ctrlBomba.AddString((LPCTSTR)szStyle);	
if (szStyle.LoadString(IDS_BMALA)) m_ctrlBomba.AddString((LPCTSTR)szStyle);
if (szStyle.LoadString(IDS_BSREDNIA)) m_ctrlBomba.AddString((LPCTSTR)szStyle);
if (szStyle.LoadString(IDS_BDUZA)) m_ctrlBomba.AddString((LPCTSTR)szStyle);

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnSelChangeWidth()
{
int nIndex = m_ctrlBomba.GetCurSel();
if (nIndex == CB_ERR) return;
CBleDoc* pDoc=(CBleDoc*)GetActiveDocument();
if (pDoc) 
{
	if (pDoc->biezacyGracz.bron[nIndex]>0) pDoc->ustawBron(nIndex);
	else 
	{
		MessageBox("Nie moesz uy tej broni.");
		pDoc->ustawBron(0);
		m_ctrlBomba.SetCurSel(0);
	};
};

SetFocus();
/*
char aaa[5];
_itoa(nIndex, aaa, 10);

MessageBox(aaa);
*/



//if (nIndex==1)

//gracz[aktywnyGracz].aktywnaBron=1;
//GetDocument()->wpiszBronIle(gracz[aktywnyGracz].podajilebroni());

return;
//nIndex - nr. pozycji z ComboBoxa, tutrzeba do tego podpiac bron

}

void CMainFrame::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default

	CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CMainFrame::UstawPole(int nIndex)
{
	 m_ctrlBomba.SetCurSel(nIndex);
}

void CMainFrame::OnHelpOpisklawiszy() 
{
	// TODO: Add your command handler code here
	okienko.DoModal();
}

void CMainFrame::ZrobComboDlaGracza(cCzolg kto)
{
	//CWnd * pCombo = GetDlgItem(IDC_CBOMB);
	//pCombo->EnableWindow();
    //CEdit * pComboEdit = (CEdit*) pCombo->GetWindow(GW_CHILD);
    //pComboEdit->ReplaceSel("Foo!");
}
